Package org.optaplanner.core.impl.score.stream.bavet

## Class BavetConstraintSession<Solution_,​Score_ extends Score<Score_>>

- java.lang.Object
- - org.optaplanner.core.impl.score.stream.bavet.BavetConstraintSession<Solution_,​Score_>

- All Implemented Interfaces:
    `AutoCloseable`, `ConstraintSession<Solution_,​Score_>`

      public final class BavetConstraintSession<Solution_,​Score_ extends Score<Score_>>
      extends Object
      implements ConstraintSession<Solution_,​Score_>

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BavetConstraintSession​(boolean constraintMatchEnabled, ScoreDefinition<Score_> scoreDefinition, Map<BavetConstraint<Solution_>,​Score_> constraintToWeightMap)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Score_` | `calculateScore​(int initScore)` |
    `void` | `close()` |
    `List<BavetFromUniNode<Object>>` | `findFromNodeList​(Class<?> factClass)` |
    `Map<String,​ConstraintMatchTotal<Score_>>` | `getConstraintMatchTotalMap()` | As defined by `InnerScoreDirector.getConstraintMatchTotalMap()`.
    `Map<Object,​Indictment<Score_>>` | `getIndictmentMap()` | As defined by `InnerScoreDirector.getIndictmentMap()`.
    `List<BavetNode>` | `getNodes()` |
    `ScoreInliner<Score_>` | `getScoreInliner()` |
    `Collection<BavetScoringNode>` | `getScoringNodes()` |
    `void` | `insert​(Object fact)` |
    `boolean` | `isConstraintMatchEnabled()` |
    `void` | `retract​(Object fact)` |
    `void` | `transitionTuple​(BavetAbstractTuple tuple, BavetTupleState newState)` |
    `void` | `update​(Object fact)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BavetConstraintSession

          public BavetConstraintSession​(boolean constraintMatchEnabled,
                                        ScoreDefinition<Score_> scoreDefinition,
                                        Map<BavetConstraint<Solution_>,​Score_> constraintToWeightMap)

  - ### Method Detail

    - #### getScoringNodes

          public Collection<BavetScoringNode> getScoringNodes()

    - #### getNodes

          public List<BavetNode> getNodes()

    - #### findFromNodeList

          public List<BavetFromUniNode<Object>> findFromNodeList​(Class<?> factClass)

    - #### insert

          public void insert​(Object fact)

      Specified by:
        `insert` in interface `ConstraintSession<Solution_,​Score_ extends Score<Score_>>`

    - #### update

          public void update​(Object fact)

      Specified by:
        `update` in interface `ConstraintSession<Solution_,​Score_ extends Score<Score_>>`

    - #### retract

          public void retract​(Object fact)

      Specified by:
        `retract` in interface `ConstraintSession<Solution_,​Score_ extends Score<Score_>>`

    - #### transitionTuple

          public void transitionTuple​(BavetAbstractTuple tuple,
                                      BavetTupleState newState)

    - #### calculateScore

          public Score_ calculateScore​(int initScore)

      Specified by:
        `calculateScore` in interface `ConstraintSession<Solution_,​Score_ extends Score<Score_>>`

    - #### getConstraintMatchTotalMap

          public Map<String,​ConstraintMatchTotal<Score_>> getConstraintMatchTotalMap()

      Description copied from interface: `ConstraintSession`
      As defined by `InnerScoreDirector.getConstraintMatchTotalMap()`.
      Specified by:
        `getConstraintMatchTotalMap` in interface `ConstraintSession<Solution_,​Score_ extends Score<Score_>>`
      Returns:
        never null

    - #### getIndictmentMap

          public Map<Object,​Indictment<Score_>> getIndictmentMap()

      Description copied from interface: `ConstraintSession`
      As defined by `InnerScoreDirector.getIndictmentMap()`.
      Specified by:
        `getIndictmentMap` in interface `ConstraintSession<Solution_,​Score_ extends Score<Score_>>`
      Returns:
        never null

    - #### close

          public void close()

      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in interface `ConstraintSession<Solution_,​Score_ extends Score<Score_>>`

    - #### isConstraintMatchEnabled

          public boolean isConstraintMatchEnabled()

    - #### getScoreInliner

          public ScoreInliner<Score_> getScoreInliner()